/*
このソースは下記からダウンロードしたものです。	2014/12/21 国野 亘

ラジオペンチ～モノいじりが好きなおじさんの探究日誌～
	http://radiopench.blog96.fc2.com/blog-entry-447.html
	http://radiopench.blog96.fc2.com/blog-entry-486.html

Lablll - Arduino Sleep_Watchdog_Battery
	http://interface.khm.de/index.php/lab/interfaces-advanced/sleep_watchdog_battery/
*/

/*
 * スタンバイ状態からウォッチドッグタイマーで起動するテスト。 
 * ＬチカをWDT割り込みで実行。
  * 2013/12/21 ラジオペンチ http://radiopench.blog96.fc2.com/
 */

//****************************************************************
/*
 * Watchdog Sleep Example 
 * Demonstrate the Watchdog and Sleep Functions
 * 
 
 * KHM 2008 / Lab3/  Martin Nawrath nawrath@khm.de
 * Kunsthochschule fuer Medien Koeln
 * Academy of Media Arts Cologne
 
 */
//****************************************************************

#include <avr/sleep.h>
#include <avr/wdt.h>

#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

// extern volatile int wdt_cycle;
// extern volatile int isr_cycle;

/*
void setup(){
  Serial.begin(9600);
  pinMode(13,OUTPUT);
  Serial.println("WDT test");
  delay(15);                            // シリアル送信待ち

//setPowDownMode();                     // オリジナルにあったが使わない
  setup_watchdog(7);                    // WDTを割り込みモードで起動
}

void loop(){
  static boolean flag=true;
  digitalWrite(13, flag);               // LED点灯（消灯）
  Serial.println(wdt_cycle);            // ちゃんとカウントされているか確認
  delay(15);                            // シリアル送信待ち
  flag = !flag;                         // フラグ反転
  system_sleep();                       // パワーダウン、WDT割り込みで復帰  
}  // loop

*/
/*	Arduino標準ライブラリの割込み設定
void setup_ardInt(byte port){
	switch(port){
		case 2 : port=0; break;
		case 3 : port=1; break;
		default: port=0; break;
	}
	attachInterrupt(port, ardISR, CHANGE);
}
void ardISR(){
	isr_cycle++;           
}
*/

void system_sleep() {                   // システム停止 
	// set system into the sleep state 
	// system wakes up when wtchdog is timed out
	cbi(ADCSRA,ADEN);					// ADC 回路電源をOFF (ADC使って無くても120μA消費するため）
	set_sleep_mode(SLEEP_MODE_PWR_DOWN);// パワーダウンモードをSLEEP_MODE_PWR_DOWNに設定(sleep mode is set here)
	sleep_enable();
	sleep_mode();						// ここでスリープに入る (System sleeps here)
	sleep_disable();					// WDTがタイムアップしたらここから動作再開 
	sbi(ADCSRA,ADEN);					// ADC ON
}

void setup_watchdog(int ii) {			// ウォッチドッグタイマーをセット。
	// 引数はWDTCSRにセットするWDP0-WDP3の値。設定値と動作時間は概略下記
	// 0=16ms, 1=32ms, 2=64ms, 3=128ms, 4=250ms, 5=500ms
	// 6=1sec, 7=2sec, 8=4sec, 9=8sec
	byte bb;
	if (ii > 9 ) ii=9;					// 変な値を排除
	bb=ii & 7;							// 下位3ビットをbbに
	if (ii > 7) bb|= (1<<5);			// 7以上（7.8,9）ならbbの5ビット目(WDP3)を1にする
	bb|= (1<<WDCE);
	MCUSR &= ~(1<<WDRF);				// MCU Status Reg. Watchdog Reset Flag ->0
	// start timed sequence
	WDTCSR |= (1<<WDCE) | (1<<WDE);		// ウォッチドッグ変更許可（WDCEは4サイクルで自動リセット）
	// set new watchdog timeout value
	WDTCSR = bb;						// 制御レジスタを設定
	WDTCSR |= _BV(WDIE);
}

void setPowDownMode(){					// CPUをパワーダウンモードに設定
	// CPU Sleep Modes
	// SM2 SM1 SM0 Sleep Mode
	// 0    0  0 Idle
	// 0    0  1 ADC Noise Reduction
	// 0    1  0 Power-down
	// 0    1  1 Power-save
	// 1    0  0 Reserved
	// 1    0  1 Reserved
	// 1    1  0 Standby(1)

	// パワーダウンモードへ設定
	cbi( SMCR,SE );      // sleep enable, power down mode
	cbi( SMCR,SM0 );     // power down mode
	sbi( SMCR,SM1 );     // power down mode
	cbi( SMCR,SM2 );     // power down mode
}
